#include <stdio.h>
#include "elisa3-lib.h"
#include "PositionController.h"
#include "Utility.h"
#ifdef _WIN32
    #include "windows.h"
#endif

#define NUM_ROBOTS 1

//******//
// MAIN //
//******//
int main(int argc, char *argv[]) {

    int currAddress[NUM_ROBOTS];
    unsigned int i, exitProg=0;

    system("mode 100, 40");

    for(i=0; i<NUM_ROBOTS; i++) {
        printf("\r\nInsert the robot%d address: ", i);
        scanf("%d", &currAddress[i]);
    }

    //enableDebugToFile();

    // init the communication with the robots; set the addresses and number of the robots to control
    startCommunication(currAddress, NUM_ROBOTS);

    // init the controller (identify robots)
    startPositionController(currAddress, NUM_ROBOTS);

    while(!exitProg) {

        positionControlExec();
        printOnTerminal(0);

        if(QKeyPressed()) {
            exitProg = 1;
        }

        if(SpaceKeyPressed()) {
            while(identifyRobotParticles());
        }

    }

    //disableDebugToFile();

    for(i=0; i<NUM_ROBOTS; i++) {
        setLeftSpeed(currAddress[i], 0);
        setRightSpeed(currAddress[i], 0);
        setRed(currAddress[i], 0);
        setGreen(currAddress[i], 0);
        setBlue(currAddress[i], 0);
        waitForUpdate(currAddress[i], 100000);
    }

    stopCommunication();

    stopPositionController();

	return 0;

}

